<a id="mypy-boto3-signer"></a>

# mypy-boto3-signer

[![PyPI - types-aiobotocore-signer](https://img.shields.io/pypi/v/types-aiobotocore-signer.svg?color=blue)](https://pypi.org/project/types-aiobotocore-signer)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-signer.svg?color=blue)](https://pypi.org/project/types-aiobotocore-signer)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-signer?color=blue)](https://pypistats.org/packages/types-aiobotocore-signer)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.signer 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/signer.html#signer)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-signer docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_signer/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-signer](#mypy-boto3-signer)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `signer`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `signer` service.

```bash
python -m pip install types-aiobotocore[signer]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[signer]` in your environment:
  `python -m pip install 'types-aiobotocore[signer]'`

Both type checking and auto-complete should work for `signer` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[signer]` in your environment:
  `python -m pip install 'types-aiobotocore[signer]'`

Both type checking and auto-complete should work for `signer` service. No
explicit type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[signer]` in your environment:
  `python -m pip install 'types-aiobotocore[signer]'`
- Run `mypy` as usual

Type checking should work for `signer` service. No explicit type annotations
required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[signer]` in your environment:
  `python -m pip install 'types-aiobotocore[signer]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `signer` service. No explicit type annotations
required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`signerClient` provides annotations for `session.create_client("signer")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_signer import signerClient

session = get_session()
with async session.create_client("signer") as client:
    client: signerClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_signer.paginator` module contains type annotations for all
paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_signer import signerClient
from types_aiobotocore_signer.paginator import (
    ListSigningJobsPaginator,
    ListSigningPlatformsPaginator,
    ListSigningProfilesPaginator,
)

session = get_session()
with async session.create_client("signer") as client:
    client: signerClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_signing_jobs_paginator: ListSigningJobsPaginator = client.get_paginator("list_signing_jobs")
        list_signing_platforms_paginator: ListSigningPlatformsPaginator = client.get_paginator("list_signing_platforms")
        list_signing_profiles_paginator: ListSigningProfilesPaginator = client.get_paginator("list_signing_profiles")
    ```


### Waiters annotations

`types_aiobotocore_signer.waiter` module contains type annotations for all waiters.

```python
from aiobotocore.session import get_session

from types_aiobotocore_signer.client import signerClient
from types_aiobotocore_signer.waiter import (
    SuccessfulSigningJobWaiter,
)

session = get_session()
with async session.create_client("signer") as client:
    client: signerClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        successful_signing_job_waiter: SuccessfulSigningJobWaiter = client.get_waiter("successful_signing_job")
    ```





<a id="literals"></a>

### Literals

`types_aiobotocore_signer.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_signer.literals import (
    CategoryType,
    EncryptionAlgorithmType,
    HashAlgorithmType,
    ImageFormatType,
    ListSigningJobsPaginatorName,
    ListSigningPlatformsPaginatorName,
    ListSigningProfilesPaginatorName,
    SigningProfileStatusType,
    SigningStatusType,
    SuccessfulSigningJobWaiterName,
    ValidityTypeType,
    ServiceName,
    PaginatorName,
    WaiterName,
)

def check_value(value: CategoryType) -> bool:
    ...
````

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_signer.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_signer.type_defs import (
    AddProfilePermissionRequestRequestTypeDef,
    AddProfilePermissionResponseTypeDef,
    CancelSigningProfileRequestRequestTypeDef,
    DescribeSigningJobRequestRequestTypeDef,
    DescribeSigningJobResponseTypeDef,
    DestinationTypeDef,
    EncryptionAlgorithmOptionsTypeDef,
    GetSigningPlatformRequestRequestTypeDef,
    GetSigningPlatformResponseTypeDef,
    GetSigningProfileRequestRequestTypeDef,
    GetSigningProfileResponseTypeDef,
    HashAlgorithmOptionsTypeDef,
    ListProfilePermissionsRequestRequestTypeDef,
    ListProfilePermissionsResponseTypeDef,
    ListSigningJobsRequestRequestTypeDef,
    ListSigningJobsResponseTypeDef,
    ListSigningPlatformsRequestRequestTypeDef,
    ListSigningPlatformsResponseTypeDef,
    ListSigningProfilesRequestRequestTypeDef,
    ListSigningProfilesResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    PaginatorConfigTypeDef,
    PermissionTypeDef,
    PutSigningProfileRequestRequestTypeDef,
    PutSigningProfileResponseTypeDef,
    RemoveProfilePermissionRequestRequestTypeDef,
    RemoveProfilePermissionResponseTypeDef,
    ResponseMetadataTypeDef,
    RevokeSignatureRequestRequestTypeDef,
    RevokeSigningProfileRequestRequestTypeDef,
    S3DestinationTypeDef,
    S3SignedObjectTypeDef,
    S3SourceTypeDef,
    SignatureValidityPeriodTypeDef,
    SignedObjectTypeDef,
    SigningConfigurationOverridesTypeDef,
    SigningConfigurationTypeDef,
    SigningImageFormatTypeDef,
    SigningJobRevocationRecordTypeDef,
    SigningJobTypeDef,
    SigningMaterialTypeDef,
    SigningPlatformOverridesTypeDef,
    SigningPlatformTypeDef,
    SigningProfileRevocationRecordTypeDef,
    SigningProfileTypeDef,
    SourceTypeDef,
    StartSigningJobRequestRequestTypeDef,
    StartSigningJobResponseTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    WaiterConfigTypeDef,
)

def get_structure() -> AddProfilePermissionRequestRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`types-aiobotocore-signer` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[types-aiobotocore-signer docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_signer/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
